<?php
/**
 * @file
 * AM_View_Helper_Field_Html class definition.
 *
 * LICENSE
 *
 * This software is governed by the CeCILL-C  license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL-C
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL-C license and that you accept its terms.
 *
 * @author Copyright (c) PadCMS (http://www.padcms.net)
 * @version $DOXY_VERSION
 */

/**
 * @ingroup AM_View_Helper
 */
class AM_View_Helper_Field_Html extends AM_View_Helper_Field
{
    public function show()
    {
        $aElements = $this->_oPage->getElementsByField($this->_oField);

        if (count($aElements)) {
            $oElement     = $aElements[0];
            /* @var $oElement AM_Model_Db_Element */
            $aElementView = array('id' => $oElement->id);

            $aExtraDataItem = array(
                AM_Model_Db_Element_Data_Html::DATA_KEY_TEMPLATE_TYPE,
                AM_Model_Db_Element_Data_Html::DATA_KEY_URL
            );

            foreach ($aExtraDataItem as $sItem) {
                $aElementView[$sItem] = $oElement->getResources()->getDataValue($sItem);
            }

            $aResourceView = $this->_getResourceViewData($oElement);
            $aElementView  = array_merge($aElementView, $aResourceView);
        }

        $aFieldView = array();

        if (isset($aElementView)) {
            $aFieldView['element'] = $aElementView;
        }

        if (!isset($aElementView) || !isset($aElementView['fileName'])) {
            $aFieldView['defaultImageUri'] = AM_Tools::getImageUrl(AM_Handler_Thumbnail_Interface::PRESET_FIELD . '-' . $this->_sPageOrientation, 'element', null, null);
        }

        $sExtensions = array_map('strtoupper', AM_Model_Db_Element_Data_Html::getAllowedFileExtensions());
        sort($sExtensions, SORT_STRING);
        $aFieldView['allowedExtensions'] = implode(' / ', $sExtensions);

        $this->_setFieldData($aFieldView);

        parent::show();
    }
}
